/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *
 *  Copyright (C) 2010 by Meika Sugimoto
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 */

#include <string>
#include <iostream>

#include "toppers/oil/oil_parser.hpp"
#include "toppers/diagnostics.hpp"

using namespace std;
using namespace boost::spirit;
using namespace toppers::oil;
using namespace toppers::oil::oil_implementation;
using namespace toppers::oil::oil_definition;


int oil_parser::do_parse(oil_impl **impl , oil_def **def)
{
	oil_grammer grammer(this);
	parse_info<> info;
	
	info = parse(description->c_str() , grammer , space_p);
	if(info.hit)
	{
		*impl = &impl_list;
		*def = &def_list;
		return 0;
	}
	else
	{
		return -1;
	}
}

void eval_tree(tree_match<char const *>::tree_iterator const &iter, int nest) {
	int size; // m[h̎q̌
	
	size = iter->children.size(); // m[h̎q̌o
	for(int i=0; i<nest; i++)
	{
		cout << "  "; // Xy[XQCfg
	}
	cout << "Node = '" << string(iter->value.begin(), iter->value.end()) << "'";
	if (size > 0)
	{
		cout << " Child Size = " << size << endl; // q̌\
	} else
	{
		cout << endl;                             // qΌ\Ȃ
	}
	for(int j=0; j<size; j++)
	{
		eval_tree(iter->children.begin()+j, nest+1); // q̌ċAĂяo
	}
}

int oil_parser::start_objimpl_analysis(std::string object_name)
{
	int result = 0;

	try
	{
		// \̃IuWFNgۑ
		current_impl = new oil_object_impl(object_name);
	}
	catch( ... )
	{
		result = -1;
	}
	
	return result;
}

int oil_parser::set_nextparam_name(std::string name)
{
	if(param_addable == true)
	{
		next_param_name = name;
	}

	return 0;
}

int oil_parser::add_parameter_objimpl(std::string parameter)
{
	// p[^́Aǉ
	if(param_addable)
	{
		current_impl->add_parameter(next_param_name , parameter);
	}

	return 0;
}

int oil_parser::start_objdef_analysis(std::string object_name_type)
{
	int result = 0;

	try
	{
		// \̃IuWFNgۑ
		current_def = new object_definition(object_name_type);
	}
	catch( ... )
	{
		result = -1;
	}
	return result;
}

int oil_parser::end_objimpl_analysis(void)
{
	// \Ao^
	impl_list.push_back(current_impl);
	
	return 0;
}

void oil_parser::enable_addparam(bool enabled)
{
	param_addable = enabled;
}

int oil_parser::end_objdef_analysis(void)
{
	static std::vector<std::string> defined_object_name;
	std::string obj_name = current_def->get_name();

	// ɓIuWFNgȂ`FbN
	if(find(defined_object_name.begin() , defined_object_name.end() , obj_name)
			== defined_object_name.end())
	{
		// \Ao^
		def_list.push_back(current_def);
		// IuWFNgǉCo^ς݂ɂ
		defined_object_name.push_back(obj_name);
	}
	else
	{
		// ̃IuWFNg݂邽߁CG[
		toppers::error("Object %1% redefined." , obj_name);
	}
	
	return 0;
}

int oil_parser::add_attr_value(string str)
{
	attr_description = str;

	if(param_addable == true)
	{
		current_def->add_parameter(next_param_name , attr_description);
	}

	return 0;
}

void oil_parser::set_error(int position , std::string message)
{
	error_position = position;
	error_message = message;
}

void oil_parser::get_error(int *position , std::string *message)
{
	*position = error_position;
	*message = error_message;
}

void oil_parser::dump_implementation(void)
{
	std::vector<oil_object_impl*>::iterator p;

	for(p = impl_list.begin(); p != impl_list.end() ; p++)
	{
		(*p)->display_implementation();
	}
}

void oil_parser::dump_definition(void)
{
	std::vector<object_definition*>::iterator p;
	
	cout << "************** Object Defition **************" << endl;
	for(p = def_list.begin(); p != def_list.end() ; p++)
	{
		(*p)->display_definition();
	}
	cout << "************** Object Defition End **************" << endl;
}
