/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *
 *  Copyright (C) 2007-2008 by TAKAGI Nobuhisa
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 */
/*!
 *  \file   toppers/output_file.hpp
 *  \brief  o̓t@CǗ߂̐錾`
 *
 *  ̃t@CŒ`NX
 *  \code
 *  class output_file;
 *  \endcode
 */
#ifndef TOPPERS_OUTPUT_FILE_HPP_
#define TOPPERS_OUTPUT_FILE_HPP_

#include <ostream>
#include <string>
#include "toppers/config.hpp"

namespace toppers
{

  /*!
   *  \class  output_file output_file.hpp "toppers/output_file.hpp"
   *  \brief  o̓t@CǗNX
   */
  class output_file
  {
  public:
    output_file() : omode_( static_cast< std::ios_base::openmode >( 0 ) ) {}
    output_file( std::string const& filename, std::ios_base::openmode omode )
      : filename_( filename ), omode_( omode ), enable_( true ) {}
    virtual ~output_file() {}

    std::ostream& ostr() const;
    std::string const& file_name() const { return filename_; }
    bool is_enable() const { return enable_; }
    void enable( bool flag = true ) { enable_ = flag; }
    void push_back( char c )
    {
      if ( enable_ )
      {
        ostr() << c;
      }
    }

    static std::string path_name( std::string const& filename );
    static std::string get_file_data( std::string const& filename );
    static bool set_file_data( std::string const& filename, std::string const& data );
    static bool clear_file_data( std::string const& filename );
    static void save();
  private:
    std::string filename_;
    std::ios_base::openmode omode_;
    bool enable_;
  };

  template < typename T >
    inline output_file const& operator << ( output_file const& ofile, T const& value )
  {
    if ( ofile.is_enable() )
    {
      ofile.ostr() << value;
    }
    return ofile;
  }

}

#endif  // ! TOPPERS_OUTPUT_FILE_HPP_
